<template>
  <div class="flex flex-col items-stretch justify-between">
    <div class="flex flex-col">
      <!-- Search Bar -->
      <div @click="searchClick()" class="p-4 text-gray-500 flex flex-row items-center clickable truncate border-b">
        <i class="hero search solid mr-4"></i>
        Search your tasks
        <modal :is="modals.get('search-modal')" raw dimmed>
          <div :style="{ height: '80vh', width: '50vw' }">
            <search-bar class="p-4 rounded bg-white" :query="searchQuery" @input="searchQuery = $event"></search-bar>
            <div class="mt-4 overflow-hidden">
              <div class="overflow-auto" :style="{ maxHeight: '70vh' }">
                <search-query-results :value="searchQuery" class="px-4" />
              </div>
            </div>
          </div>
        </modal>
      </div>
      <views edit />
    </div>

    <!-- Navigation -->
    <div class="flex flex-row items-center justify-between text-gray-900">
      <div class="clickable p-4 flex flex-row items-center truncate" @click="openWorkspaceCreator()">
        <i class="hero plus solid mr-2"></i>
        <div class="">
          Add Workspace
        </div>
      </div>
      <i class="hero adjustments outline clickable-bg p-2 m-2 rounded-full" @click="modals.show('settings')"></i>
    </div>

    <modal :is="modals.get('workspaces-creator')" desktop-position="center" v-slot:default="{ modal }" dimmed>
      <workspaces-detail :workspace="newWorkspace" focus class="max-w-md p-4" @saved="modal.hide()" />
    </modal>

    <modal :is="modals.inlined('settings')" dimmed>
      <settings style="min-width: 30em" />
    </modal>
  </div>
</template>

<script lang="ts">
import { useModals, inlined } from "@/use/modal";
import { openView } from "@/use/navigation";
import { computed, ref, watch } from "vue";
import router from "@/router";
import SearchBar from "@/components/Search/Bar.vue";
import WorkspacesIndicator from "@/components/Workspaces/Indicator.vue";
import TasksList from "@/components/Tasks/List.vue";
import SearchQueryResults from "@/components/Search/SearchQueryResults.vue";
import SidebarEntry from "@/components/SidebarEntry.vue";
import WorkspacesDetail from "@/components/Workspaces/Detail.vue";
import Views from "@/components/Views.vue";
import { RouteLocationRaw } from "vue-router";
import Workspace from "@/models/Workspace";
import Setting from "@/models/Setting";
import Settings from "./Settings.vue";

export default {
  components: {
    SearchBar,
    WorkspacesIndicator,
    TasksList,
    SearchQueryResults,
    SidebarEntry,
    Views,
    WorkspacesDetail,
    Settings
  },
  setup() {
    const modals = useModals({ SearchModal: inlined(), WorkspacesCreator: inlined() });
    const searchQuery = computed({
      get: () => router.currentRoute.value.query.searchquery,
      set: value =>
        router.replace({
          ...router.currentRoute.value,
          query: { ...router.currentRoute.value.query, searchquery: value }
        })
    });

    watch(
      () => router.currentRoute.value.query.searchquery,
      (current, previous) => {
        if (current != undefined && previous === undefined) {
          modals.show("search-modal");
        } else if (current === undefined && previous != undefined) {
          modals.hide("search-modal");
        }
      },
      { immediate: true }
    );

    watch(
      () => modals.get("search-modal")?.state.show,
      (current, previous) => {
        const route = router.currentRoute.value;
        if (!current && route.query.searchquery != undefined) {
          router.replace({
            ...route,
            query: { ...route.query, searchquery: undefined }
          });
        }
      },
      { immediate: true }
    );

    const newWorkspace = ref(new Workspace());

    return {
      searchClick: () => {
        const current = router.currentRoute.value;
        router.push({
          ...current,
          query: { ...current.query, searchquery: "" }
        });
      },
      searchQuery,
      isView: (name: string) => router.currentRoute.value.name == name,
      openView,
      modals,
      workspaces: computed(() => Workspace.query().getSync()),
      isActiveWorkspace: (checkWorkspace: Workspace) =>
        router.currentRoute.value.name == "Tasks" && router.currentRoute.value.params.workspace == checkWorkspace.id,
      openWorkspaceCreator: ($event: MouseEvent) => {
        newWorkspace.value = new Workspace();
        modals.show("workspaces-creator", $event);
      },
      newWorkspace
    };
  }
};
</script>
